/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: Bestellung.java,v 1.5 2004/02/10 16:20:32 tk4 Exp $
 */
package haendler;

import idman.mngt.Context;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Random;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Klasse zur Verarbeitung von Bezahldokumenten.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: Bestellung.java,v 1.5 2004/02/10 16:20:32 tk4 Exp $
 */
public class Bestellung {

	private static boolean Fehler_generieren = false;
	private BestellSatz neueBestellung = new BestellSatz();
	private boolean Status = true;
	private String ErrorMsg = "";
	private Random rnd = new Random();
	private int rndHash = 0;
	private Document bestellung = null;
	private Context context = null;

	public boolean getStatus() {
		return Status;
	}
	public String getError() {
		return ErrorMsg;
	}
	public Document getBestellung() {
		return bestellung;
	}

	public Bestellung(
		Document doc,
		Haendler haendlerInstance,
		Context context) {
		this.context = context;
		readData(doc, haendlerInstance);
		if (Status == true) {
			writeData(haendlerInstance);
		}
		if (Status == true) {
			sigData(haendlerInstance);
		}
		if (Status == true) {
			haendlerInstance.addBestellSatz(neueBestellung);
		}
		if (Status == true) {
			System.out.println("Bestellung fertig");
		}
	}
	public Bestellung(
		BestellSatz repeatSatz,
		Haendler haendlerInstance,
		Context context) {
		this.context = context;
		neueBestellung = repeatSatz;
		if (Status == true) {
			writeData(haendlerInstance);
		}
		if (Status == true) {
			sigData(haendlerInstance);
		}
		if (Status == true) {
			System.out.println("Mangel-Bestellung fertig");
		}
	}
	protected void readData(Document doc, Haendler haendlerInstance) {

		// Erstmal testen...
		Document[] docs = haendlerInstance.verify(doc, context);
		if ((docs == null) || (docs.length != 1)) {
			Status = false;
			if (docs.length == 0) {
				ErrorMsg = "Bestellung nicht signiert.";
			} else {
				ErrorMsg = "Bestellung verletzt Protokoll.";
			}
			return;
		}
		doc = docs[0];

		NodeList treuhaenderList = doc.getElementsByTagName("Treuhaender");
		if (treuhaenderList.getLength() == 0) {
			ErrorMsg = "Bestellung ... kein Treuhaender gefunden";
			Status = false;
			return;
		}
		Node thNode = treuhaenderList.item(0);
		String TName = "TName";
		String TAdresse = "";
		String TTelefon = "";
		String TIPAdresse = "";
		String TPort = "";
		if (thNode.hasChildNodes()) {
			thNode = thNode.getFirstChild();
			do {
				if (thNode.getNodeName().equals("TName"))
					TName = thNode.getFirstChild().getNodeValue();
				if (thNode.getNodeName().equals("TAdresse"))
					TAdresse = thNode.getFirstChild().getNodeValue();
				if (thNode.getNodeName().equals("TTelefon"))
					TTelefon = thNode.getFirstChild().getNodeValue();
				if (thNode.getNodeName().equals("TIPAdresse"))
					TIPAdresse = thNode.getFirstChild().getNodeValue();
				if (thNode.getNodeName().equals("TPort"))
					TPort = thNode.getFirstChild().getNodeValue();
				thNode = thNode.getNextSibling();
			} while (thNode != null);
		}
		neueBestellung.setTreuhaender(
			TName,
			TAdresse,
			TTelefon,
			TIPAdresse,
			TPort);
		//	System.out.println("Bestellung ... Treuhaender-Pseudonym gefunden: "+ neueBestellung.getTName());

		//Haendler-Daten auslesen und vergleichen
		NodeList haendlerList = doc.getElementsByTagName("Haendler");
		if (haendlerList.getLength() == 0) {
			ErrorMsg = "Bestellung ... kein Haendler gefunden";
			Status = false;
			return;
		}
		Node haendlerNode = haendlerList.item(0);
		String HName = "";
		String HIPAdresse = "";
		String HPort = "";
		if (haendlerNode.hasChildNodes()) {
			haendlerNode = haendlerNode.getFirstChild();
			do {
				if (haendlerNode.getNodeName().equals("HName")) {
					HName = haendlerNode.getFirstChild().getNodeValue();
				}
				if (haendlerNode.getNodeName().equals("HIPAdresse")) {
					HIPAdresse = haendlerNode.getFirstChild().getNodeValue();
				}
				if (haendlerNode.getNodeName().equals("HPort")) {
					HPort = haendlerNode.getFirstChild().getNodeValue();
				}
				haendlerNode = haendlerNode.getNextSibling();
			} while (haendlerNode != null);
		}
		neueBestellung.setHaendler(HName, HIPAdresse, HPort);
		//	System.out.println("Bestellung ... Haendler-Pseudonym gefunden: "+ neueBestellung.getHName());

		/* Frueher mal...
		if (!haendlerInstance.verify(doc, neueBestellung.getTName())){
		    System.out.println("Bestellung: Signatur FALSCH ...");
		    ErrorMsg = "Bestellung ... Validierung des Treuhaender-Pseudonym "+
			"fehlgeschlagen";
		    Status=false;
		    return;
		}
		*/
		//Katalog_Nr auslesen
		NodeList katalogNrList = doc.getElementsByTagName("Katalog_Nr");
		if (katalogNrList.getLength() == 0) {
			ErrorMsg = "Bestellung ... Keine Katalognummer angegeben";
			Status = false;
			return;
		} else {
			neueBestellung.setKatalogNr(
				katalogNrList.item(0).getFirstChild().getNodeValue());
			//	   System.out.println("Bestellung ... Katalognummer: " + neueBestellung.getKatalogNr());
		}
		// Bestell_ID auslesen
		NodeList bestellIDList = doc.getElementsByTagName("Bestell_ID");
		if (bestellIDList.getLength() == 0) {
			ErrorMsg = "Bestellung ... Keine Bestell_ID angegeben";
			Status = false;
			return;
		} else {
			neueBestellung.setBestellID(
				bestellIDList.item(0).getFirstChild().getNodeValue());
			//	   System.out.println("Bestellung ... Bestell_ID: " + neueBestellung.getBestellID());
		}
		//Bestellung bearbeiten
		NodeList bestellungList = doc.getElementsByTagName("Gesamtbestellung");
		if (bestellungList.getLength() == 0) {
			ErrorMsg = "Bestellung ... Keine Bestellungen enthalten";
			Status = false;
			return; //ABBRUCH
		}
		NodeList eintragList = doc.getElementsByTagName("Eintrag");
		if (eintragList.getLength() == 0) {
			ErrorMsg = "Bestellung ... Kein Bestell-Eintrag enthalten";
			Status = false;
			return; //ABBRUCH
		}
		Node eintrag;
		for (int i = 0; i < eintragList.getLength(); i++) {
			eintrag = eintragList.item(i);
			String newID = "";
			String newPreis = "";
			if (eintrag.hasChildNodes()) {
				eintrag = eintrag.getFirstChild();
				do {
					if (eintrag.getNodeName().equals("ID")) {
						newID = eintrag.getFirstChild().getNodeValue();
					}
					if (eintrag.getNodeName().equals("Preis")) {
						newPreis = eintrag.getFirstChild().getNodeValue();
						newPreis = parsePrice(newPreis);
					}
					eintrag = eintrag.getNextSibling();
				} while (eintrag != null);
				Eintrag n = new Eintrag(newID, newPreis);
				//		System.out.println("ID: " + n.ID + ", Preis: " + n.Preis);
				neueBestellung.addEintrag(n);
			}
		}
		//Ges_Preis auslesen
		NodeList PreisList = doc.getElementsByTagName("Ges_Preis");
		if (PreisList.getLength() == 0) {
			ErrorMsg = "Bestellung ... Keine Ges_Preis angegeben";
			Status = false;
			return;
		} else {
			String gesPreis =
				parsePrice(PreisList.item(0).getFirstChild().getNodeValue());
			neueBestellung.setGesPreis(gesPreis);
			//	   System.out.println("Bestellung ... GesPreis: " + neueBestellung.getGesPreis());
		}

		// Preise vergleichen
		int sumi = 0;
		for (int i = 0; i < neueBestellung.sizeOfEintragList(); i++) {
			Eintrag b = (Eintrag) neueBestellung.EintragList.elementAt(i);
			sumi += parsePriceToInt(b.Preis);
		}
		//	System.out.println("Gesamtsumme als int: " + sumi);
		int sumg = parsePriceToInt(neueBestellung.getGesPreis());
		if (sumi != sumg) {
			ErrorMsg = "Bestellung ... Gesamtpreis falsch";
			Status = false;
			return;
		}
	}
	protected void writeData(Haendler haendlerInstance) {
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document result = db.newDocument();

			Element lieferunght = result.createElement("Lieferunght");
			result.appendChild(lieferunght);

			Element haendler = result.createElement("Haendler");
			lieferunght.appendChild(haendler);

			Element hname = result.createElement("HName");
			hname.appendChild(
				result.createTextNode(haendlerInstance.getName()));
			haendler.appendChild(hname);

			Element hipadresse = result.createElement("HIPAdresse");
			hipadresse.appendChild(
				result.createTextNode(haendlerInstance.getIPAdresse()));
			haendler.appendChild(hipadresse);

			Element hport = result.createElement("HPort");
			hport.appendChild(
				result.createTextNode(haendlerInstance.getPort()));
			haendler.appendChild(hport);

			Element treuhaender = result.createElement("Treuhaender");
			lieferunght.appendChild(treuhaender);

			Element tname = result.createElement("TName");
			tname.appendChild(result.createTextNode(neueBestellung.getTName()));
			treuhaender.appendChild(tname);

			Element tadresse = result.createElement("TAdresse");
			tadresse.appendChild(
				result.createTextNode(neueBestellung.getTAdresse()));
			treuhaender.appendChild(tadresse);

			Element ttelefon = result.createElement("TTelefon");
			ttelefon.appendChild(
				result.createTextNode(neueBestellung.getTTelefon()));
			treuhaender.appendChild(ttelefon);

			Element tipadresse = result.createElement("TIPAdresse");
			tipadresse.appendChild(
				result.createTextNode(neueBestellung.getTIPAdresse()));
			treuhaender.appendChild(tipadresse);

			Element tport = result.createElement("TPort");
			tport.appendChild(result.createTextNode(neueBestellung.getTPort()));
			treuhaender.appendChild(tport);

			Element bestellid = result.createElement("Bestell_ID");
			bestellid.appendChild(
				result.createTextNode(neueBestellung.getBestellID()));
			lieferunght.appendChild(bestellid);

			for (int i = 0; i < neueBestellung.sizeOfEintragList(); i++) {
				try {
					Eintrag b =
						(Eintrag) neueBestellung.EintragList.elementAt(i);
					String BookContent = getFileContent(b.ID);
					String BookHash = haendlerInstance.hash(BookContent);

					Element ware = result.createElement("Ware");
					lieferunght.appendChild(ware);

					Element book = result.createElement("Book");
					book.appendChild(result.createTextNode(BookContent));
					ware.appendChild(book);

					Element bsignaturh = result.createElement("BSignatur_H");
					if (((rndHash = rndInt()) == 0) && (!Fehler_generieren)) {
						bsignaturh.appendChild(result.createTextNode(BookHash));
					} else {
						bsignaturh.appendChild(result.createTextNode("Fehler"));
					}
					ware.appendChild(bsignaturh);
				} catch (Exception e) {
					ErrorMsg = "Bestellung ... Fehler beim Lieferung erstellen";
					Status = false;
					return;
				}
			}
			bestellung = result;
		} catch (Exception e) {
			System.out.println("Bestellung#writeData: " + e.getMessage());
		}
	}
	protected void sigData(Haendler haendlerInstance) {
		Document sigDoc = bestellung;
		if (sigDoc == null) {
			ErrorMsg = "Bestellung ... Fehler beim Parsen";
			Status = false;
			return;
		}
		sigDoc = haendlerInstance.sign(sigDoc, context);
		if (sigDoc == null) {
			ErrorMsg = "Bestellung ... Fehler bei Signieren";
			Status = false;
		}
		bestellung = sigDoc;
	}
	protected String getFileContent(String FileName) {
		String result = "";
		File input = new File(FileName + ".txt");
		try {
			InputStream in = null;
			if (input.exists())
				in = new FileInputStream(input);
			else
				in = getClass().getResourceAsStream("/" + FileName + ".txt");
			int c = in.available();
			byte[] b = new byte[c];
			c = in.read(b);
			result = new String(b);
			in.close();
		} catch (Exception ex) {
		}
		return result;
	}
	protected String parsePrice(String price) {
		price = price.replace(',', '.');
		int i = price.indexOf("DM");
		if (i == -1)
			return price;
		int l = price.length();
		return price.substring(0, i) + price.substring(i + 2, l);
	}
	protected float parsePriceToFloat(String price) {
		Float priceF = new Float(price);
		//	System.out.println(priceF.floatValue());
		return priceF.floatValue();
	}
	protected int parsePriceToInt(String price) {
		int priceInt = 0;
		float priceF = parsePriceToFloat(price) * 100;
		priceInt = (int) priceF;
		return priceInt;
	}
	protected int rndInt() {
		rnd = new Random(System.currentTimeMillis());
		int number = rnd.nextInt(100);
		if (number > 95) {
			return number;
		} else {
			return 0;
		}
	}

	// -------------------------------------

	public static class BestellSatz {

		private String KatalogNr;
		private String BestellID;
		private String TName;
		private String TAdresse;
		private String TTelefon;
		private String TIPAdresse;
		private String TPort;
		private String HName;
		private String HIPAdresse;
		private String HPort;
		private Vector EintragList = new Vector();
		private String GesPreis;

		public BestellSatz() {
		}
		protected void setKatalogNr(String KNr) {
			KatalogNr = KNr;
		}
		protected String getKatalogNr() {
			return KatalogNr;
		}
		protected void setBestellID(String BID) {
			BestellID = BID;
		}
		protected String getBestellID() {
			return BestellID;
		}
		protected void setTreuhaender(
			String TN,
			String TAdr,
			String TTel,
			String TIP,
			String TP) {
			TName = TN;
			TAdresse = TAdr;
			TTelefon = TTel;
			TIPAdresse = TIP;
			TPort = TP;
		}
		protected void setTName(String TN) {
			TName = TN;
		}
		protected void setTAdresse(String TAdr) {
			TAdresse = TAdr;
		}
		protected void setTTelefon(String TTel) {
			TTelefon = TTel;
		}
		protected void setTIPAdresse(String TIP) {
			TIPAdresse = TIP;
		}
		protected void setTPort(String TP) {
			TPort = TP;
		}
		protected String getTName() {
			return TName;
		}
		protected String getTAdresse() {
			return TAdresse;
		}
		protected String getTTelefon() {
			return TTelefon;
		}
		protected String getTIPAdresse() {
			return TIPAdresse;
		}
		protected String getTPort() {
			return TPort;
		}
		protected void setHaendler(String HN, String HIP, String HP) {
			HName = HN;
			HIPAdresse = HIP;
			HPort = HP;
		}
		protected void setHName(String HN) {
			HName = HN;
		}
		protected String getHName() {
			return HName;
		}
		protected void setHIPAdresse(String HIP) {
			HIPAdresse = HIP;
		}
		protected void setHPort(String HP) {
			HPort = HP;
		}
		protected String getHIPAdresse() {
			return HIPAdresse;
		}
		protected String getHPort() {
			return HPort;
		}
		protected void addEintrag(Eintrag n) {
			EintragList.addElement(n);
		}
		protected int sizeOfEintragList() {
			return EintragList.size();
		}
		protected void setGesPreis(String GP) {
			GesPreis = GP;
		}
		protected String getGesPreis() {
			return GesPreis;
		}
	}

	public static class Eintrag {

		private String ID;
		private String Preis;

		public Eintrag(String newID, String newPreis) {
			ID = newID;
			Preis = newPreis;
		}
		public String getID() {
			return ID;
		}
		public String getPreis() {
			return Preis;
		}
	}
}
