/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: Katalog.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
package haendler;

import idman.mngt.Context;

import org.w3c.dom.Document;

/**
 * Klasse zur Verarbeitung von Katalogdokumenten.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: Katalog.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
public class Katalog {

	private boolean Status = true;
	private String ErrorMsg = "";
	private Document katalog = null;

	public Katalog(Document doc, Haendler haendlerInstance, Context context) {
		katalog = haendlerInstance.getDocFromFile("katalog.xml");
		katalog = haendlerInstance.sign(katalog, context);

		//	System.out.println(haendlerInstance.HName_);
		if (katalog == null) {
			ErrorMsg = "Katalog ... Signieren fehlgeschlagen";
			Status = false;
			return;
		}
	} // END Konstruktor Katalog(Document doc, Haendler haendlerInstance);

	// -------------------------------------

	public boolean getStatus() {
		return Status;
	}

	public String getError() {
		return ErrorMsg;
	}

	public Document getKatalog() {
		return katalog;
	}
}
