/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: MainClass.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
package haendler;

import idman.dbi.Database;
import idman.util.Configuration;

import java.util.Properties;

import org.ssonet.util.Preload;

/**
 * Zentrale Startklasse bernimmt die Kommandozeilenauswertung.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: MainClass.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
public class MainClass {

	/**
	 * Startmethode.
	 * Parameter:
	 * <ul>
	 * <li>-name &lt;name&gt; Name (Bob) fr Personenpseudonym.
	 * <li>-role &lt;name&gt; Name (Hndler) der Rolle fr Verbindungsannahme.
	 * <li>-port &lt;port&gt; Port (4013) fr Verbindungsannahme.
	 * </ul>
	 * @param args Parameter.
	 * @throws Exception Im Fehlerfall.
	 */
	public static void main(String[] args) throws Exception {
		args = parseArgs(args);
		Preload preload = new Preload();
		Properties settings = Configuration.getSettings();
		settings.setProperty("mngt.certificate.subjectCN", args[2]);
		Database.getDBI(settings);
		Haendler haendler = new Haendler(settings, args[0], args[1]);
		preload.join();
		haendler.start();
	}

	private static String[] parseArgs(String[] args) {
		String[] result = { "Hndler", "4013", "Bob" };
		for (int i = 0; i < args.length; i++) {
			String c = args[i];
			if ("-role".equals(c)) {
				i++;
				if (i == args.length)
					usage();
				else
					result[0] = args[i];
			} else if ("-name".equals(c)) {
				i++;
				if (i == args.length)
					usage();
				else
					result[2] = args[i];
			} else if ("-port".equals(c)) {
				i++;
				if (i == args.length)
					usage();
				else
					result[1] = args[i];
				try {
					int j = Integer.parseInt(result[1]);
					if (j <= 1024)
						System.out.println("Port must be above 1024.");
				} catch (NumberFormatException nfe) {
					System.out.println(
						"Port must be a positive number " + "above 1024.");
				}
			} else {
				usage();
			}
		}
		return result;
	}
	private static void usage() {
		System.out.println(
			"Usage:   [-name <name>] [-role role] [-port <port>]");
		System.out.println("Default: -name Bob -role Hndler -port 4013");
		System.exit(0);
	}
}
