/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: ServerSalesMan.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
package haendler;

import java.net.ServerSocket;

import org.ssonet.net.SSONETContextFactory;
import org.ssonet.net.impl.SSONETServerClientSocket;
import org.ssonet.net.impl.SSONETServerSocket;

/**
 * Diese Klasse bernimmt die Kommunikation mit dem Client,
 * stellt sich fuer ihn also als Server dar.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: ServerSalesMan.java,v 1.4 2004/02/10 16:20:32 tk4 Exp $
 */
public class ServerSalesMan extends Thread {

	private ServerSocket server;
	private Haendler haendler;

	/**
	 * Konstruktor.
	 * @param haendler Verarbeiter.
	 * @param port Port fr Verbindungsannahme.
	 * @param factory Fabrik fr Kontexte.
	 */
	public ServerSalesMan(
		Haendler haendler,
		int port,
		SSONETContextFactory factory) {
		try {
			this.haendler = haendler;
			this.server = new SSONETServerSocket(port, factory);
		} catch (Exception e) {
			System.out.println("ServerSalesMan<init>: " + e.getMessage());
		}
	}
	/**
	 * Nimmt Verbindungan an und bergibt sie an ClientSalesMan zur
	 * Verarbeitung.
	 */
	public void run() {
		while (true) {
			try {
				SSONETServerClientSocket client =
					(SSONETServerClientSocket) server.accept();
				new ClientSalesMan(client, haendler).start();
			} catch (Exception e) {
				e.printStackTrace();
				break;
			}
		}
	}
}
