/**
 * @version working
 * @author Thomas Kriegelstein
 * $Id: Help.java,v 1.3 2004/02/10 16:20:33 tk4 Exp $
 */
package kunde;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

/**
 * Klasse zur Anzeige von Informationen.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: Help.java,v 1.3 2004/02/10 16:20:33 tk4 Exp $
 */
public class Help extends JMenu implements ActionListener {

	private final JMenuItem infoItem = new JMenuItem("Verwendete Aktionen");
	private final JMenuItem aboutItem = new JMenuItem("ber");

	private MainFrame mainFrame = null;

	public Help(MainFrame mainFrame) {
		this.setText("Hilfe");
		this.add(infoItem);
		infoItem.addActionListener(this);
		this.add(aboutItem);
		aboutItem.addActionListener(this);
		this.mainFrame = mainFrame;
	}

	public void actionPerformed(ActionEvent ae) {
		Object source = ae.getSource();
		if (source == infoItem)
			infoItemActionPerformed();
		if (source == aboutItem)
			aboutItemActionPerformed();
	}

	private void aboutItemActionPerformed() {
		String[] arr =
			{
				"Showcase, Kunde",
				"(c) 2001-2002 Thomas Kriegelstein",
				"Technical University of Dresden" };
		javax.swing.JOptionPane.showMessageDialog(mainFrame, arr);
	}
	private void infoItemActionPerformed() {
		String[] arr =
			{
				"Beispielanwendung fr Identittsmanager",
				"SHOWCASE - Kunde",
				" ",
				"Folgende Aktionen werden ausgefhrt:",
				"+ Kataloganforderung in Rolle: "
					+ mainFrame.traderData.getPseudonym(),
				"+ Bestellung in Rolle: "
					+ mainFrame.trusteeData.getPseudonym()};
		javax.swing.JOptionPane.showMessageDialog(mainFrame, arr);
	}

}
