/**
 * @version working
 * @author lehrprojekt
 * @author Thomas kriegelstein
 * $Id: Kunde.java,v 1.5 2004/02/10 16:20:33 tk4 Exp $
 */
package kunde;

import idman.util.Configuration;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Point;
import java.util.Date;
import java.util.Properties;

import javax.swing.JLabel;
import javax.swing.JWindow;

/**
 * Startklasse fr die Kundenapplikation.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: Kunde.java,v 1.5 2004/02/10 16:20:33 tk4 Exp $
 */
public class Kunde {
	/**
	 * Startmethode mit Parameterauswertung.
	 * Parameter:
	 * <ul>
	 * <li>-name &lt;name&gt; Name fr Personenpseudonym.
	 * <li>-rmi Anbindung per RMI statt eigenen Manager.
	 * </ul>
	 * @param args Parameter.
	 * @throws Exception Im Fehlerfall.
	 */
	public static void main(String[] args) throws Exception {
		args = parseArgs(args);
		// do something
		Properties settings = null;
		// done
		MainFrame main = null;
		if ("true".equals(args[0])) {
			// Besser: cfg/rmi.properties oder sowas...
			settings = new Properties();
			settings.setProperty("rmi.registry", "localhost");
			settings.setProperty("rmi.usessl", "false");
			settings.setProperty("mngt.certificate.subjectCN", args[1]);
			main = new MainFrameRMI(settings);
		} else {
			settings = Configuration.getSettings();
			settings.setProperty("mngt.certificate.subjectCN", args[1]);
			main = new MainFrame(settings);
			try {
				new ClientCustomer(null);
			} catch (NullPointerException ignore) {
			} // WebStart / JDK 1.4 Issue
		}
		main.setEnabled(false);
		Dimension d = main.getToolkit().getScreenSize();
		Dimension i = main.getSize();
		main.setLocation((d.width - i.width) / 2, (d.height - i.height) / 2);
		main.setVisible(true);
		JWindow message = new JWindow(main);
		Insets ins = main.getInsets();
		Point p = main.getLocation();
		message.setBounds(
			(i.width - ins.left - ins.right - 300) / 2 + ins.left + p.x,
			(i.height - ins.top - ins.bottom - 200) / 2 + ins.top + p.y,
			300,
			200);
		//message.setBackground(Color.lightGray);
		//message.setForeground(Color.black);
		message.getContentPane().setLayout(null);
		JLabel l1 = new JLabel("Initialisierung luft ...");
		l1.setHorizontalAlignment(JLabel.CENTER);
		l1.setBounds(0, 70, 300, 15);
		JLabel l2 = new JLabel("Bitte etwas Geduld !");
		l2.setHorizontalAlignment(JLabel.CENTER);
		l2.setBounds(0, 120, 300, 15);
		message.getContentPane().add(l1);
		message.getContentPane().add(l2);
		message.show();
		main.log(new Date(), "Initialisiere...", "");
		// do something, or at least pretend to do..
		main.init(settings);
		// done
		message.dispose();
		main.setEnabled(true);
		main.log(new Date(), "Initialisierung abgeschlossen", "Fertig");
	}
	private static String[] parseArgs(String[] args) {
		String[] result = { "false", "Alice" };
		for (int i = 0; i < args.length; i++) {
			if ("-rmi".equals(args[i])) {
				result[0] = "true";
			} else if ("-name".equals(args[i])) {
				i++;
				if (i == args.length)
					usage();
				else
					result[1] = args[i];
			} else {
				usage();
			}
		}
		return result;
	}
	private static void usage() {
		System.err.println("Usage:  [-name <name>] [-rmi]");
		System.err.println("Default: -name Alice");
		System.exit(0);
	}
}
