/**
 * @version working
 * @author lehrprojekt
 * $Id: ListObject.java,v 1.2 2004/02/10 16:20:33 tk4 Exp $
 */
package kunde;

import org.w3c.dom.Node;

/**
 * Klasse fr XML-verarbeitende Listenobjekte.
 * @author lehrprojekt
 * @version $Id: ListObject.java,v 1.2 2004/02/10 16:20:33 tk4 Exp $
 */
public class ListObject {

	private int catalogIndex = 0;
	private int number = 0;
	private Node item = null;
	private ListObject next = null;

	protected ListObject() {
	}

	protected ListObject(int ci, Node i) {
		catalogIndex = ci;
		item = i;
		next = null;
		number = 0;
	}

	protected void addNumber(int n) {
		number += n;
	}

	protected int getCatalogIndex() {
		return catalogIndex;
	}

	protected Node getItem() {
		return item;
	}

	protected ListObject getNext() {
		return next;
	}

	protected int getNumber() {
		return number;
	}

	protected void setCatalogIndex(int ci) {
		catalogIndex = ci;
	}

	protected void setItem(Node i) {
		item = i;
	}

	protected void setNext(ListObject lo) {
		next = lo;
	}

	protected void subNumber(int n) {
		number -= n;
		if (number < 0)
			number = 0;
	}
}
