/**
 * @version working
 * @author Thomas Kriegelstein
 * $Id: LogModel.java,v 1.4 2004/02/10 16:20:33 tk4 Exp $
 */
package kunde;

/**
 * Model zur Verwaltung der Protokollierungseintrge in der Tabelle.
 * @author Thomas Kriegelstein
 * @version $Id: LogModel.java,v 1.4 2004/02/10 16:20:33 tk4 Exp $
 */
public class LogModel extends javax.swing.table.AbstractTableModel {

	private String[] names = { "Datum", "Aktion", "Ergnzung" };
	private Object[][] mydata = {
	};
	private Class[] classes = { Object.class, String.class, String.class };

	public String getColumnName(int c) {
		return names[c];
	}
	public Class getColumnClass(int c) {
		return classes[c];
	}
	public boolean isCellEditable(int r, int c) {
		return false;
	}
	public int getColumnCount() {
		return names.length;
	}
	public int getRowCount() {
		return mydata.length;
	}
	public void setValueAt(Object o, int r, int c) {
		// Not editable!
	}
	public Object getValueAt(int r, int c) {
		return mydata[r][c];
	}
	public void log(java.util.Date date, String id, String content) {
		Object[][] tmp = new Object[mydata.length + 1][];
		Object[] arr = new Object[names.length];
		System.arraycopy(mydata, 0, tmp, 1, mydata.length);
		tmp[0] = arr;
		arr[0] = date;
		arr[1] = id;
		arr[2] = content;
		mydata = tmp;
		fireTableDataChanged();
	}
}
