/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: MyList.java,v 1.2 2004/02/10 16:20:33 tk4 Exp $
 */
package kunde;

import javax.swing.JList;
import org.w3c.dom.Node;

/**
 * Basisklasse zur Verwaltung und Anzeige XML-verarbeitender Listen.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: MyList.java,v 1.2 2004/02/10 16:20:33 tk4 Exp $
 */
public class MyList extends JList {

	protected Node[] nodes;
	protected String[] datas;
	protected int count;
	protected boolean initialized;
	protected int lastSelectedItem;

	public MyList() {
		count = 0;
		nodes = new Node[0];
		datas = new String[0];
		initialized = false;
		lastSelectedItem = -1;
	}

	public void setArray(int size) {
		initialized = true;
		nodes = new Node[size];
		datas = new String[size];
		setListData(datas);
	}

	public void add(String des, Node n) {
		nodes[count] = n;
		datas[count] = des;
		count++;
		setListData(datas);
	}

	public String getSelectedItem() {
		return (String) getSelectedValue();
	}

	public Node getNode(int index) {
		return nodes[index];
	}

	public boolean isInitialized() {
		return initialized;
	}

	public void setCount(int c) {
		count = c;
	}

	public void setInitialized(boolean i) {
		initialized = i;
	}

	public void setLastSelectedItem(int item) {
		lastSelectedItem = item;
	}

	public int getLastSelectedItem() {
		return lastSelectedItem;
	}
}
