/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: MySelectedItems.java,v 1.5 2004/02/11 07:55:08 tk4 Exp $
 */
package kunde;

import javax.swing.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import java.util.Vector;

/**
 * Klasse zur Verwaltung und Darstellung der Bestellung.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: MySelectedItems.java,v 1.5 2004/02/11 07:55:08 tk4 Exp $
 */
public class MySelectedItems extends JList implements MouseListener {

	protected Node trader = null;
	protected Node catalogNumber = null;
	protected ListObject first = null;
	protected ListObject last = null;
	private int listIndex = 0;
	protected long sum = 0;
	protected int lastSelectedIndex = -1;
	protected MainFrame mainFrame = null;

	protected String[] datas = {
	};

	public MySelectedItems(MainFrame mainFrame) {
		setListData(datas);
		this.addMouseListener(this);
		this.mainFrame = mainFrame;
	}

	public void mouseClicked(MouseEvent m) {
		itemSelected();
	}
	public void mouseEntered(MouseEvent m) {
	}
	public void mouseExited(MouseEvent m) {
	}
	public void mousePressed(MouseEvent m) {
	}
	public void mouseReleased(MouseEvent m) {
	}

	public int getItemCount() {
		if (first == null)
			return 0;
		int count = 0;
		ListObject next = first;
		for (count = 1; null != (next = next.getNext()); count++);
		return count;
	}

	public String getSelectedItem() {
		return (String) getSelectedValue();
	}

	private void refreshList() {
		if (first == null) {
			datas = new String[0];
			setListData(datas);
		}
		ListObject next = first;
		int count = getItemCount();
		datas = new String[count];
		for (count = 0; null != next; count++) {
			NodeList list = next.getItem().getChildNodes();
			String name = "";
			for (int j = 0; j < list.getLength(); j++) {
				if (list.item(j).getNodeName().equals("Titel"))
					name = list.item(j).getFirstChild().getNodeValue();
			}
			datas[count] = "" + next.getNumber() + " x " + name;
			next = next.getNext();
		}
		setListData(datas);
	}

	protected void add(int ci, Node i, String text, int number) {
		NodeList list = i.getChildNodes();
		String pr = "";
		for (int j = 0; j < list.getLength(); j++) {
			if (list.item(j).getNodeName().equals("Preis"))
				pr = list.item(j).getFirstChild().getNodeValue();
		}
		pr = Trader.parsePrice(pr);
		float pri;
		try {
			pri = Float.parseFloat(pr);
		} catch (NumberFormatException nfe) {
			return;
		}
		long price = (long) new Float(pri * 100).intValue();
		sum += price * number;
		pr = new Float(new Long(sum).floatValue() / 100).toString();
		int su = pr.indexOf(".");
		if (pr.length() == su + 2)
			pr += "0";
		pr = pr.replace('.', ',');
		mainFrame.setTotal(pr);
		ListObject lo = this.testOnCatalogItem(ci);
		if (lo == null) {
			lo = new ListObject(ci, i);
			lo.addNumber(number);
			if (first == null) {
				first = lo;
				last = lo;
			} else {
				last.setNext(lo);
				last = lo;
			}
		} else {
			lo.addNumber(number);
		}
		mainFrame.setOrderEnabled(true);
		refreshList();
	}

	protected int getLastSelectedIndex() {
		return lastSelectedIndex;
	}
	/**
	 * Vector: [trader:Node, catalogNumber:Node, (item:Node,
	 * count:Integer)*]
	 */
	protected Vector getOrder() {
		Vector v = new Vector();
		v.add(trader);
		v.add(catalogNumber);
		ListObject current = first;
		while (current != null) {
			v.add(current.getItem());
			v.add(new Integer(current.getNumber()));
			current = current.getNext();
		}
		return v;
	}

	protected long getSum() {
		return sum;
	}

	protected void itemSelected() {
		if (this.getSelectedIndex() == -1)
			return;
		if (this.getLastSelectedIndex() == this.getSelectedIndex()) {
			mainFrame.removeActionPerformed();
		} else {
			this.setLastSelectedIndex(this.getSelectedIndex());
			mainFrame.setNumber("1");
			mainFrame.setRemoveEnabled(true);
		}
	}

	protected void setLastSelectedIndex(int i) {
		lastSelectedIndex = i;
	}

	protected void resetSum() {
		sum = 0;
	}

	protected void resetList() {
		first = null;
		last = null;
		refreshList();
	}

	protected void setTrader(Node t) {
		trader = t;
	}

	protected void setCatalogNumber(Node cn) {
		catalogNumber = cn;
	}

	protected void sub(int selectedIndex, int number) {
		ListObject current = first, beforeCurrent = first;
		if (selectedIndex != 0) {
			for (int i = 0; i < selectedIndex; i++) {
				beforeCurrent = current;
				current = current.getNext();
			}
		}
		if (current.getNumber() < number)
			number = current.getNumber();
		NodeList list = current.getItem().getChildNodes();
		String pr = "";
		for (int j = 0; j < list.getLength(); j++) {
			if (list.item(j).getNodeName().equals("Preis"))
				pr = list.item(j).getFirstChild().getNodeValue();
		}
		pr = Trader.parsePrice(pr);
		float pri;
		try {
			pri = Float.parseFloat(pr);
		} catch (NumberFormatException nfe) {
			return;
		}
		long price = (long) new Float(pri * 100).intValue();
		sum -= price * number;
		pr = new Float(new Long(sum).floatValue() / 100).toString();
		int su = pr.indexOf(".");
		if (pr.length() == su + 2)
			pr += "0";
		pr = pr.replace('.', ',');
		mainFrame.setTotal(pr);
		if (number == current.getNumber()) {
			if (first == last) {
				this.first = null;
				this.last = null;
				this.setLastSelectedIndex(-1);
				mainFrame.setRemoveEnabled(false);
			} else {
				if (current == beforeCurrent)
					first = current.getNext();
				else {
					if (current.getNext() == null)
						last = beforeCurrent;
					else {
						beforeCurrent.setNext(current.getNext());
					}
				}
			}
			this.setLastSelectedIndex(-1);
			mainFrame.setRemoveEnabled(false);
			if (this.getItemCount() == 0)
				mainFrame.setOrderEnabled(false);
			refreshList();
		} else {
			current.subNumber(number);
			String text = this.getSelectedItem();
			int index = text.indexOf(" x");
			text = text.substring(index);
			text = new Integer(current.getNumber()).toString() + " " + text;
			index = this.getSelectedIndex();
			refreshList();
			this.setSelectedIndex(index);
		}
	}

	protected ListObject testOnCatalogItem(int ci) {
		if (first == null)
			return null;
		ListObject current = first, back = null;
		listIndex = 0;
		do {
			if (current.getCatalogIndex() == ci) {
				back = current;
				current = null;
			} else {
				current = current.getNext();
				listIndex++;
			}
		} while (current != null);
		return back;
	}
}
