/**
 * @version working
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * $Id: ServerTrustee.java,v 1.4 2004/02/10 16:20:33 tk4 Exp $
 */
package treuhaender;

import java.net.ServerSocket;

import org.ssonet.net.SSONETContextFactory;
import org.ssonet.net.impl.SSONETServerClientSocket;
import org.ssonet.net.impl.SSONETServerSocket;

/**
 * Diese Klasse bernimmt die Kommunikation mit dem Client, stellt sich fr
 * ihn also als Server dar.
 * @author lehrprojekt
 * @author Thomas Kriegelstein
 * @version $Id: ServerTrustee.java,v 1.4 2004/02/10 16:20:33 tk4 Exp $
 */
public class ServerTrustee extends Thread {

	private ServerSocket server;
	private Treuhaender treuhaender;

	/**
	 * Konstruktor.
	 * @param treuhaender Verweis auf den Bearbeiter der Anfragen.
	 * @param port Port fr die Kommunikation mit dem Client.
	 * @param factory Verweis auf eine Fabrik fr Kontexte (SSONET).
	 */
	public ServerTrustee(
		Treuhaender treuhaender,
		int port,
		SSONETContextFactory factory) {
		try {
			this.treuhaender = treuhaender;
			this.server = new SSONETServerSocket(port, factory);
		} catch (Exception e) {
			System.out.println("ServerTrustee<init>: " + e.getMessage());
		}
	}
	/**
	 * Akzeptiert Verbindungen und bergibt sie an ClientTrustee
	 * zur Bearbeitung.
	 */
	public void run() {
		while (true) {
			try {
				SSONETServerClientSocket client =
					(SSONETServerClientSocket) server.accept();
				new ClientTrustee(client, treuhaender).start();
			} catch (Exception e) {
				e.printStackTrace();
				break;
			}
		}
	}
}
